import { AuthenticableEntity } from '@repo/types';
import { Request } from 'express';
import { AuthService } from './auth.service';
import { SignupAuthenticableEntityDto } from './dtos/signup-authenticable-entity.dto';
export declare class AuthController {
    private readonly authService;
    constructor(authService: AuthService);
    getToken(entity: string, signupUserDto: SignupAuthenticableEntityDto): Promise<{
        token: string;
    }>;
    signupAdmin(signupUserDto: SignupAuthenticableEntityDto): Promise<{
        token: string;
    }>;
    signup(entity: string, signupUserDto: SignupAuthenticableEntityDto): Promise<{
        token: string;
    }>;
    getCurrentUser(_entity: string, req: Request): Promise<AuthenticableEntity>;
    isDefaultAdminExists(): Promise<{
        exists: boolean;
    }>;
}
