import { AuthenticableEntity, BaseEntity, DatabaseConnection } from '@repo/types';
import { EntitySchema, EntitySchemaColumnOptions } from 'typeorm';
import { RelationshipService } from './relationship.service';
import { EntityManifestService } from '../../manifest/services/entity-manifest.service';
export declare class EntityLoaderService {
    private entityManifestService;
    private relationshipService;
    constructor(entityManifestService: EntityManifestService, relationshipService: RelationshipService);
    loadEntities(dbConnection: DatabaseConnection): EntitySchema[];
    getBaseEntityColumns(dbConnection: DatabaseConnection): {
        [key in keyof BaseEntity]: EntitySchemaColumnOptions;
    };
    getBaseAuthenticableEntityColumns(dbConnection: DatabaseConnection): {
        [key in keyof AuthenticableEntity]: EntitySchemaColumnOptions;
    };
}
