import { BaseEntity, EntityManifest, RelationshipManifest } from '@repo/types';
import { EntitySchemaRelationOptions } from 'typeorm';
import { EntityService } from './entity.service';
import { EntityManifestService } from '../../manifest/services/entity-manifest.service';
export declare class RelationshipService {
    private entityManifestService;
    private entityService;
    constructor(entityManifestService: EntityManifestService, entityService: EntityService);
    getSeedValue(relationshipManifest: RelationshipManifest): number | {
        id: number;
    }[];
    getEntitySchemaRelationOptions(entityManifest: EntityManifest): {
        [key: string]: EntitySchemaRelationOptions;
    };
    fetchRelationItemsFromDto({ itemDto, relationships, emptyMissing }: {
        itemDto: object;
        relationships: RelationshipManifest[];
        emptyMissing?: boolean;
    }): Promise<{
        [key: string]: BaseEntity | BaseEntity[];
    }>;
}
