import { EntityManifest, EntitySchema, CrudEventName, HookManifest, HooksSchema, PropertyManifest, PropertySchema, MiddlewaresSchema, MiddlewareManifest } from '@repo/types';
import { RelationshipManifestService } from './relationship-manifest.service';
import { ManifestService } from './manifest.service';
import { HookService } from '../../hook/hook.service';
import { PolicyService } from '../../policy/policy.service';
export declare class EntityManifestService {
    private relationshipManifestService;
    private manifestService;
    private hookService;
    private policyService;
    constructor(relationshipManifestService: RelationshipManifestService, manifestService: ManifestService, hookService: HookService, policyService: PolicyService);
    getEntityManifests(options?: {
        fullVersion?: boolean;
    }): EntityManifest[];
    getEntityManifest({ className, slug, fullVersion }: {
        className?: string;
        slug?: string;
        fullVersion?: boolean;
    }): EntityManifest;
    transformEntityManifests(entitySchemaObject: {
        [keyof: string]: EntitySchema;
    }): EntityManifest[];
    private getCollectionEntityManifestProps;
    private getSingleEntityManifestProps;
    transformProperty(propSchema: PropertySchema, entitySchema: EntitySchema): PropertyManifest;
    transformHookObject(hooksSchema: HooksSchema): Record<CrudEventName, HookManifest[]>;
    transformMiddlewareObject(middlewareSchema: MiddlewaresSchema): Record<CrudEventName, MiddlewareManifest[]>;
    hideEntitySensitiveInformation(entityManifest: EntityManifest): EntityManifest;
}
