import { SchemaService } from './schema.service';
import { YamlService } from './yaml.service';
import { AppManifest } from '@repo/types';
import { EntityManifestService } from './entity-manifest.service';
import { EndpointService } from '../../endpoint/endpoint.service';
import { ConfigService } from '@nestjs/config';
export declare class ManifestService {
    private yamlService;
    private schemaService;
    private entityManifestService;
    private endpointService;
    private readonly configService;
    private appManifest;
    constructor(yamlService: YamlService, schemaService: SchemaService, entityManifestService: EntityManifestService, endpointService: EndpointService, configService: ConfigService);
    getAppManifest(options?: {
        fullVersion?: boolean;
    }): AppManifest;
    loadManifest(manifestFilePath: string): Promise<void>;
    hideSensitiveInformation(manifest: AppManifest): AppManifest;
}
