import { BaseEntity, EntityManifest, PropertyManifest } from '@repo/types';
import { DataSource, Repository } from 'typeorm';
import { EntityService } from '../../entity/services/entity.service';
import { RelationshipService } from '../../entity/services/relationship.service';
import { StorageService } from '../../storage/services/storage.service';
import { EntityManifestService } from '../../manifest/services/entity-manifest.service';
export declare class SeederService {
    private entityService;
    private relationshipService;
    private entityManifestService;
    private storageService;
    private dataSource;
    seededFiles: {
        [key: string]: string;
    };
    seededImages: {
        [key: string]: {
            [key: string]: string;
        };
    };
    constructor(entityService: EntityService, relationshipService: RelationshipService, entityManifestService: EntityManifestService, storageService: StorageService, dataSource: DataSource);
    seed(tableName?: string): Promise<void>;
    seedProperty(propertyManifest: PropertyManifest, entityManifest: EntityManifest): Promise<string | number | boolean | object | unknown>;
    private seedRichText;
    private seedChoice;
    private seedFile;
    private seedImage;
    private seedLocation;
    seedAdmin(repository: Repository<BaseEntity>): Promise<void>;
}
